// Any use of this code and/or information below is subject to the
// license terms: http://wireless.java.sun.com/berkeley_license.html

import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class SimpleGameMIDlet
    extends MIDlet
    implements CommandListener {
  private Display mDisplay;
  
  private SimpleGameCanvas mCanvas;
  private Command mExitCommand;
  
  public void startApp() {
    if (mCanvas == null) {
      mCanvas = new SimpleGameCanvas();
      mCanvas.start();
      mExitCommand = new Command("Exit", Command.EXIT, 0);
      mCanvas.addCommand(mExitCommand);
      mCanvas.setCommandListener(this);
    }
    
    mDisplay = Display.getDisplay(this);
    mDisplay.setCurrent(mCanvas);
  }
  
  public void pauseApp() {}
  
  public void destroyApp(boolean unconditional) {
    mCanvas.stop();
  }
  
  public void commandAction(Command c, Displayable s) {
    if (c.getCommandType() == Command.EXIT) {
      destroyApp(true);
      notifyDestroyed();
    }
  }
}
